Public Class AddLineForm

    Private Const IN_BOUND_CALL_REJECT As Integer = 0
    Private Const IN_BOUND_CALL_CONNECT_USER As Integer = 1
    Private Const IN_BOUND_CALL_PUT_IN_QUEUE As Integer = 2

    Private Function AddLineChecks(ByRef sInCallTo As String, ByRef sInCallType As String) As Boolean

        AddLineChecks = False

        If ComboLine.Text.Length = 0 Then
            MessageBox.Show("Please enter Line Name.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Function
        End If

        If ListBoxEnableCodec.Items.Count = 0 Then
            MessageBox.Show("Please select a codec.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Function
        End If

        sInCallType = "0"

        If RadioConnectToUser.Checked = True Then
            If ComboConnectToUser.SelectedIndex = -1 Then
                MessageBox.Show("Please select the user/login to forward the incoming call.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Function
            End If

            sInCallType = "1"
            sInCallTo = ComboConnectToUser.SelectedItem.ToString()

        ElseIf RadioPutInQueue.Checked Then
            If ComboPutInQueue.SelectedIndex = -1 Then
                MessageBox.Show("Please select the queue to put the incoming call.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Function
            End If

            sInCallType = "2"
            sInCallTo = ComboPutInQueue.SelectedItem.ToString()
        End If

        AddLineChecks = True

    End Function

    Private Sub BtnAddLine_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddLine.Click

        Dim sInCallTo As String = ""
        Dim sInCallType As String = ""

        If AddLineChecks(sInCallTo, sInCallType) = False Then
            Exit Sub
        End If

        If ComboLine.FindStringExact(ComboLine.Text) <> -1 Then

            If MessageBox.Show("Line already exist, do you want to update it?", "VaxTeleSIP", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) = Windows.Forms.DialogResult.No Then
                Exit Sub
            End If

        End If

        Dim objParamList As ArrayList = New ArrayList

        objParamList.Add(ComboLine.Text)

        objParamList.Add(EditDisplayName.Text)
        objParamList.Add(EditUserName.Text)
        objParamList.Add(EditAuthUser.Text)
        objParamList.Add(EditPassword.Text)
        objParamList.Add(EditDomainRealm.Text)
        objParamList.Add(EditProxySIP.Text)
        objParamList.Add(EditOutboundProxySIP.Text)

        Dim objCodec As New cCodec
        Dim sCodec As String = ""

        Dim nCount As Integer

        For nCount = 0 To ListBoxEnableCodec.Items.Count - 1
            sCodec += objCodec.GetCodecNo(ListBoxEnableCodec.Items.Item(nCount))
        Next

        objParamList.Add(sCodec)

        If CheckBoxRegLine.Checked = True Then
            objParamList.Add("REGISTER-YES")
        Else
            objParamList.Add("REGISTER-NO")
        End If

        objParamList.Add(sInCallType)
        objParamList.Add(sInCallTo)

        MainForm.m_objTelnetClient.SendCommand("AddLine", objParamList)

    End Sub

    Private Sub AddLineForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        MainForm.m_objMainForm.SendCommand("ShowLines", Nothing)
        ClearDlgContent()

    End Sub

    Private Sub ClearDlgContent()

        ComboLine.Text = ""

        EditUserName.Text = ""
        EditAuthUser.Text = ""
        EditPassword.Text = ""
        EditDisplayName.Text = ""
        EditDomainRealm.Text = ""
        EditProxySIP.Text = ""
        EditOutboundProxySIP.Text = ""

        If ComboConnectToUser.Items.Count > 0 Then
            ComboConnectToUser.SelectedIndex = 0
        End If

        If ComboPutInQueue.Items.Count > 0 Then
            ComboPutInQueue.SelectedIndex = 0
        End If

        CheckBoxRegLine.Checked = False
        RadioRejectCall.Checked = True

        ListBoxEnableCodec.Items.Clear()
        ListBoxDisableCodec.Items.Clear()

        ListBoxEnableCodec.Items.Add(cCodec.G711U_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.G711A_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.ILBC_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.G610_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.G729_TEXT)

    End Sub

    Private Sub BtnDisableCodec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDisableCodec.Click
        If ListBoxEnableCodec.SelectedItems.Count = 0 Then
            Exit Sub
        End If

        ListBoxDisableCodec.Items.Add(ListBoxEnableCodec.SelectedItem.ToString())
        ListBoxEnableCodec.Items.Remove(ListBoxEnableCodec.SelectedItem)
    End Sub

    Private Sub BtnEnableCodec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnEnableCodec.Click
        If ListBoxDisableCodec.SelectedItems.Count = 0 Then
            Exit Sub
        End If

        ListBoxEnableCodec.Items.Add(ListBoxDisableCodec.SelectedItem.ToString())
        ListBoxDisableCodec.Items.Remove(ListBoxDisableCodec.SelectedItem)
    End Sub

    Private Sub UpdateDlgContent(ByVal sLineName As String, ByVal sDisplayName As String, ByVal sUserName As String, ByVal sAuthUser As String, ByVal sAuthPwd As String, ByVal sRealm As String, ByVal sProxy As String, ByVal sOutboundProxy As String, ByVal sCodecList As String, ByVal sRegister As String, ByVal sInCallType As String, ByVal sInCallTo As String)

        If ComboLine.Text <> sLineName Then
            Exit Sub
        End If

        EditDisplayName.Text = sDisplayName
        EditUserName.Text = sUserName

        EditAuthUser.Text = sAuthUser
        EditPassword.Text = sAuthPwd
        EditDomainRealm.Text = sRealm

        EditProxySIP.Text = sProxy
        EditOutboundProxySIP.Text = sOutboundProxy

        If sRegister = "REGISTER-YES" Then
            CheckBoxRegLine.Checked = True
        Else
            CheckBoxRegLine.Checked = False
        End If

        UpdateIncomingCallSection(Convert.ToInt32(sInCallType), sInCallTo)

        ListBoxEnableCodec.Items.Clear()
        ListBoxDisableCodec.Items.Clear()

        Dim nCount As Integer
        Dim objCodec As New cCodec

        For nCount = 0 To cCodec.TOTAL_SIZE_CODEC
            ListBoxDisableCodec.Items.Add(objCodec.GetCodecName(Convert.ToString(nCount)))
        Next

        Dim sCodecName As String

        For nCount = 0 To sCodecList.Length - 1
            sCodecName = objCodec.GetCodecName(sCodecList(nCount))
            ListBoxEnableCodec.Items.Add(sCodecName)
            ListBoxDisableCodec.Items.Remove(sCodecName)
        Next

    End Sub

    Private Sub UpdateIncomingCallSection(ByVal nInCallType As Integer, ByVal sInCallTo As String)

        Dim nIndex As Integer

        If nInCallType = IN_BOUND_CALL_REJECT Then
            RadioRejectCall.Checked = True

        ElseIf nInCallType = IN_BOUND_CALL_CONNECT_USER Then

            nIndex = ComboConnectToUser.FindStringExact(sInCallTo)

            If nIndex = -1 Then
                RadioRejectCall.Checked = True
                Exit Sub
            End If

            If ComboConnectToUser.Items.Count > 0 Then
                ComboConnectToUser.SelectedIndex = nIndex
            End If

            RadioConnectToUser.Checked = True

        ElseIf nInCallType = IN_BOUND_CALL_PUT_IN_QUEUE Then

            nIndex = ComboPutInQueue.FindStringExact(sInCallTo)

            If nIndex = -1 Then
                RadioRejectCall.Checked = True
                Exit Sub
            End If

            If ComboPutInQueue.Items.Count > 0 Then
                ComboPutInQueue.SelectedIndex = nIndex
            End If

            RadioPutInQueue.Checked = True

        End If

    End Sub

    Private Sub ComboLine_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboLine.SelectedIndexChanged

        Dim objParamList As ArrayList = New ArrayList
        objParamList.Add(ComboLine.SelectedItem.ToString())

        MainForm.m_objMainForm.SendCommand("LineInfo", objParamList)

    End Sub

    Private Sub BtnRemoveLine_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRemoveLine.Click

        If ComboLine.Text.Length = 0 Then
            MessageBox.Show("Please enter line name.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        Dim objParamList As ArrayList = New ArrayList
        objParamList.Add(ComboLine.Text)

        MainForm.m_objMainForm.SendCommand("RemoveLine", objParamList)
        
    End Sub

    Private Sub BtnClearLineDlg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClearLineDlg.Click
        ClearDlgContent()
    End Sub

    Public Sub OnTelnetCommand(ByVal sCommand As String, ByRef objParamList As ArrayList)

        If String.Compare(sCommand, "AddUser", True) = 0 And objParamList.Count = 1 Then

            ComboConnectToUser.Items.Add(objParamList.Item(0))

            Exit Sub
        End If

        If String.Compare(sCommand, "RemoveUser", True) = 0 And objParamList.Count = 1 Then

            Dim nIndex As Integer = ComboConnectToUser.FindStringExact(objParamList.Item(0))
            If nIndex = -1 Then
                Exit Sub
            End If

            ComboConnectToUser.Items.RemoveAt(nIndex)

            Exit Sub
        End If

        If String.Compare(sCommand, "AddQueue", True) = 0 And objParamList.Count = 1 Then

            ComboPutInQueue.Items.Add(objParamList.Item(0))

            Exit Sub
        End If

        If String.Compare(sCommand, "RemoveQueue", True) = 0 And objParamList.Count = 1 Then

            Dim nIndex As Integer = ComboPutInQueue.FindStringExact(objParamList.Item(0))
            If nIndex = -1 Then
                Exit Sub
            End If

            ComboPutInQueue.Items.RemoveAt(nIndex)

            Exit Sub
        End If

        If String.Compare(sCommand, "ShowQueues", True) = 0 Then

            Dim nCount As Integer

            For nCount = 0 To objParamList.Count - 1
                ComboPutInQueue.Items.Add(objParamList.Item(nCount))
            Next

            If ComboPutInQueue.Items.Count > 0 Then
                ComboPutInQueue.SelectedIndex = 0
            End If

            Exit Sub
        End If

        If String.Compare(sCommand, "ShowUsers", True) = 0 Then

            Dim nCount As Integer

            For nCount = 0 To objParamList.Count - 1
                ComboConnectToUser.Items.Add(objParamList.Item(nCount))
            Next

            If ComboConnectToUser.Items.Count > 0 Then
                ComboConnectToUser.SelectedIndex = 0
            End If

            Exit Sub
        End If

        If String.Compare(sCommand, "ShowLines", True) = 0 Then

            Dim nCount As Integer

            For nCount = 0 To objParamList.Count - 1
                ComboLine.Items.Add(objParamList.Item(nCount))
            Next

            If ComboLine.Items.Count > 0 Then
                ComboLine.SelectedIndex = 0
            End If

            Exit Sub
        End If

        If String.Compare(sCommand, "LineInfo", True) = 0 And objParamList.Count = 12 Then

            Dim sLineName As String = objParamList.Item(0)
            Dim sDisplayName As String = objParamList.Item(1)
            Dim sUserName As String = objParamList.Item(2)
            Dim sAuthUser As String = objParamList.Item(3)
            Dim sAuthPwd As String = objParamList.Item(4)
            Dim sRealm As String = objParamList.Item(5)
            Dim sProxy As String = objParamList.Item(6)
            Dim sOutboundProxy As String = objParamList.Item(7)

            Dim sCodecList As String = objParamList.Item(8)

            Dim sRegister As String = objParamList.Item(9)
            Dim sInCallType As String = objParamList.Item(10)
            Dim sInCallTo As String = objParamList.Item(11)

            UpdateDlgContent(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sRealm, sProxy, sOutboundProxy, sCodecList, sRegister, sInCallType, sInCallTo)

            Exit Sub
        End If

        If String.Compare(sCommand, "RemoveLine", True) = 0 And objParamList.Count = 1 Then

            Dim nIndex As Integer = ComboLine.FindStringExact(objParamList.Item(0))
            If nIndex = -1 Then
                Exit Sub
            End If

            ComboLine.Items.RemoveAt(nIndex)

            MessageBox.Show("Line removed successfully!", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            ClearDlgContent()

            Exit Sub
        End If

        If String.Compare(sCommand, "AddLine", True) = 0 And objParamList.Count = 1 Then

            ComboLine.Items.Add(objParamList.Item(0))
            MessageBox.Show("Line created successfully", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

            Exit Sub
        End If

        If String.Compare(sCommand, "UpdateLine", True) = 0 And objParamList.Count = 1 Then

            MessageBox.Show("Line updated successfully", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

    End Sub

End Class