Public Class cErrorLog

    Public Sub LogError(ByVal sError As String)

        If sError.Length = 0 Then
            SendError()
        Else
            Dim objParamList As New ArrayList
            objParamList.Add(sError)

            cTelnetServer.m_objTelnetServer.SendCommandToAll("ErrorLog", objParamList)
        End If

    End Sub

    Private Sub SendError()

        Dim sErrorText As String

        Dim nVaxErrorCode As Integer = cServerSIP.m_objServerSIP.GetVaxObjectError()

        Select Case (nVaxErrorCode)

            Case 200
                sErrorText = "Fail to initialize RTP Socket."

            Case 201
                sErrorText = "Fail to allocate RTP port or RTP listen IP is not correct."

            Case 202
                sErrorText = "Fail to create RTP task manager."

            Case 203
                sErrorText = "Fail to start media thread."

            Case 204
                sErrorText = "Fail to create RTP communication manager."

            Case 205
                sErrorText = "Unable to use RTP communication manager."

            Case 206
                sErrorText = "Unable to open file."

            Case 207
                sErrorText = "Unable to read file."

            Case 208
                sErrorText = "Wave file format is not correct, please use 8000Hz, 16bit, mono uncompressed wave file."

            Case 209
                sErrorText = "Invalid play wave ID."

            Case 210
                sErrorText = "Fail to start recording manager."

            Case 211
                sErrorText = "Call is not in the voice session."

            Case 212
                sErrorText = "Fail to initialize VaxTele object."

            Case 213
                sErrorText = "Error to create SDP body."

            Case 214
                sErrorText = "Error to create INVITE request."

            Case 215
                sErrorText = "Error to initialize SIP communication layer."


            Case 216
                sErrorText = "Error to open SIP listen port or SIP listen IP is not correct."


            Case 217
                sErrorText = "Error to create SIP task manager."


            Case 218
                sErrorText = "Error to create REGISTER request."


            Case 219
                sErrorText = "Error to create UN-REGISTER request."


            Case 220
                sErrorText = "Error to create BYE request."


            Case 221
                sErrorText = "Error to create CANCEL request."


            Case 222
                sErrorText = "Call-Id is not valid or call does not exist."


            Case 223
                sErrorText = "Session-Id is not valid or session does not exist."


            Case 224
                sErrorText = "Login does not exist."


            Case 225
                sErrorText = "Login length is not correct."


            Case 226
                sErrorText = "Line does not exist."


            Case 227
                sErrorText = "Cann't send SIP response."


            Case 228
                sErrorText = "SIP response code is not valid, please check SIP RFC 3261."


            Case 229
                sErrorText = "Error to create SIP message."


            Case 230
                sErrorText = "Line already exist."


            Case 231
                sErrorText = "Reg-Id is not correct or does not exist."


            Case 232
                sErrorText = "Error to create SIP reponse."


            Case 233
                sErrorText = "User is not registered."


            Case 234
                sErrorText = "Invalid codec OR there is no codec found for voice streaming."


            Case 235
                sErrorText = "Invalid DTMF type."


            Case 236
                sErrorText = "Other party does not support RFC2833 DTMF digits."


            Case 237
                sErrorText = "Error to create REFER request to transfer the call."


            Case 238
                sErrorText = "Error to create event handler."


            Case 239
                sErrorText = "Invalid license key."


            Case 240
                sErrorText = "Invalid digit for DTMF."


            Case 241
                sErrorText = "Invalid proxy URI."


            Case 242
                sErrorText = "Line is not register."


            Case Else
                Exit Sub

        End Select

        Dim sError As String
        sError = Convert.ToString(nVaxErrorCode) + " : " + sErrorText

        Dim objParamList As New ArrayList
        objParamList.Add(sError)

        cTelnetServer.m_objTelnetServer.SendCommandToAll("ErrorLog", objParamList)

    End Sub

End Class
