#pragma once

using namespace System;
using namespace System::Collections;
using namespace System::Text;

ref class cCallData;
ref class cQueueData;

public ref class cQueueData
{
public:
	cQueueData();

public:

    int m_nQueueDigitDetectPlayWaveId;
    int m_nQueuePlayWaveId;

    bool m_bIsDigitDetect;
    unsigned int m_unQueueId;

    ArrayList^ m_objAgentList;
    ArrayList^ m_objQueueCallList;

    Hashtable^ m_objDigitDetectList;
};

ref class cQueueList
{
public:
	cQueueList(void);

private:
	
	bool FindFreeUserId(ArrayList^ objListOP, String^% sFreeUserId);
	void PlayQueueWaveToCall(cCallData^ objCallData, int nQueueWaveId, bool bLoopPlay);
	void UpdateCall(cCallData^ objCallData, cQueueData^ objQueueData);
	void DistributeCall(cQueueData^ objQueueData);
	bool DistributeCallToQueueAgent(cQueueData^ objQueueData, cCallData^ objQueueCallData);
	bool DistributeCallToDigitPressUser(cQueueData^ objQueueData, cCallData^ objQueueCallData);
	bool DialCallToDigitPRESS(cQueueData^ objQueueData, cCallData^ objQueueCallData);
	void Remove(String^ sQueueName);
	void Add(String^ sQueueName, String^ sQueuePlayWave, String^ sDigitPressPlayWave, ArrayList^ objAgentList, ArrayList^ objPressDigitList, ArrayList^ objUserDigitList);

public:

	bool FindUserForDigitPRESS(cQueueData^ objQueueData, String^ sDigitPRESS, String^ sDigitPressUSER);
	void OnPressDigitDTMF(cCallData^ objCallData, String^ sDigit);

public:

	unsigned int m_unQueueIdCount;

    Hashtable^ m_objQueueListTEXT;
    Hashtable^ m_objQueueListINT;

public:

	void UnLoadQueue();
	unsigned int ChooseQueueId();
	void LoadQueue();
	void ProcessQueueTick();

	void DeleteAll();
	
	cQueueData^ FindQueue(String^ sQueueName);
	cQueueData^ FindQueue(unsigned int unQueueId);

	bool AddQueue(String^ sQueueName, String^ sQueuePlayWave, String^ sDigitPressPlayWave, ArrayList^ objAgentList, ArrayList^ objPressDigitList, ArrayList^ objUserDigitList);
	bool RemoveQueue(String^ sQueueName);

	void OnPlayWaveDoneToCall(cCallData^ objCallData);
	void PlayDialToneToCall(cCallData^ objCallData);

	void RemoveQueueCall(cCallData^ objCallData);
	bool AddCallToQueue(cCallData^ objCallData);
	
};
