#include "StdAfx.h"
#include "ServerData.h"
#include "ServerSIP.h"
#include "QueueList.h"
#include "LineList.h"
#include "CallList.h"
#include "DialPlanList.h"
#include "Registry.h"

cServerData::cServerData(void)
{
	m_nHoldSession = -1;
    m_nHoldPlayWaveId = -1;

    m_nDialToneWaveId = -1;
    m_nDialToneSession = -1;

    m_nStealthSession = -1;
	m_nStealthWaveId = -1;
}

int cServerData::GetDialToneSessionId()
{
    return m_nDialToneSession;
}

int cServerData::GetStealthSessionId()
{
    return m_nStealthSession;
}

int cServerData::GetHoldSessionId()
{
    return m_nHoldSession;
}

void cServerData::LoadWavFiles()
{
    cRegistry^ objReg = gcnew cRegistry();

    String^ sHoldMusicWaveFile = objReg->GetHoldMusic();
    String^ sDialToneWaveFile = objReg->GetDialToneMusic();
    String^ sStealthMusicWaveFile = objReg->GetStealthListenerMusic();

    if(sHoldMusicWaveFile->Length != 0)
        cServerSIP::m_objServerSIP->LoadWaveFileToSession(sHoldMusicWaveFile, m_nHoldPlayWaveId, m_nHoldSession);
    
    if(sDialToneWaveFile->Length != 0)
        cServerSIP::m_objServerSIP->LoadWaveFileToSession(sDialToneWaveFile, m_nDialToneWaveId, m_nDialToneSession);
    
    if(sStealthMusicWaveFile->Length != 0)
        cServerSIP::m_objServerSIP->LoadWaveFileToSession(sStealthMusicWaveFile, m_nStealthWaveId, m_nStealthSession);
}

void cServerData::UnLoadWavFiles()
{
    cServerSIP::m_objServerSIP->UnLoadWaveFileToSession(m_nHoldPlayWaveId, m_nHoldSession);
    cServerSIP::m_objServerSIP->UnLoadWaveFileToSession(m_nDialToneWaveId, m_nDialToneSession);
    cServerSIP::m_objServerSIP->UnLoadWaveFileToSession(m_nStealthWaveId, m_nStealthSession);
}

void cServerData::LoadServer()
{
    LoadWavFiles();

    cServerSIP::m_objServerSIP->m_objLineList->LoadLines();
    cServerSIP::m_objServerSIP->m_objDialPlanList->LoadDialPlans();
    cServerSIP::m_objServerSIP->m_objQueueList->LoadQueue();

    cServerSIP::m_objServerSIP->SetVaxTeleTick(QUEUE_TICK_ID, 2000); //2 seconds.
}

void cServerData::UnLoadServer()
{
    UnLoadWavFiles();

    cServerSIP::m_objServerSIP->m_objLineList->UnLoadLines();
    cServerSIP::m_objServerSIP->m_objDialPlanList->UnLoadDialPlans();
    cServerSIP::m_objServerSIP->m_objQueueList->UnLoadQueue();

    cServerSIP::m_objServerSIP->KillVaxTeleTick(QUEUE_TICK_ID);
}
