#include "StdAfx.h"
#include "ServerSIP.h"
#include "QueueList.h"
#include "LineList.h"
#include "CallList.h"
#include "DialPlanList.h"
#include "TelnetCmd.h"
#include "Registry.h"
#include "TelnetClient.h"

cTelnetCmd::cTelnetCmd(void)
{
}

void cTelnetCmd::ShowUsers(cTelnetClient^ objTelnetClient)
{
    cRegistry^ objReg = gcnew cRegistry();

    ArrayList^ objLoginList = gcnew ArrayList();
    objReg->EnumLogin(objLoginList);

    objTelnetClient->SendCommand("ShowUsers", objLoginList);
    objTelnetClient->SendText("VaxTele:>");
}

void cTelnetCmd::UserInfo(ArrayList^ objParamList, cTelnetClient^ objTelnetClient)
{
    String^ sLogin = (String^) objParamList[0];

    cRegistry^ objReg = gcnew cRegistry();
    
    cLoginReg^ objLoginReg = gcnew cLoginReg();
    ArrayList^ objSendParamList = gcnew ArrayList();

    if(objReg->GetLogin(sLogin, objLoginReg)== false)
    {
        objSendParamList->Add("User not found.");
        objTelnetClient->SendCommand("MSG", objSendParamList);
        objTelnetClient->SendText("VaxTele:>");

        return;
    }

    objSendParamList->Add(sLogin);
    objSendParamList->Add(objLoginReg->m_sPassword);
    objSendParamList->Add(objLoginReg->m_sCodec);

    if(objLoginReg->m_bStealth)
        objSendParamList->Add("STEALTH-YES");
    else
        objSendParamList->Add("STEALTH-NO");
    

    if(objLoginReg->m_bBlock)
        objSendParamList->Add("BLOCK-YES");
    else
        objSendParamList->Add("BLOCK-NO");
    
    objTelnetClient->SendCommand("UserInfo", objSendParamList);
    objTelnetClient->SendText("VaxTele:>");
}

void cTelnetCmd::AddUser(ArrayList^ objParamList, cTelnetClient^ objTelnetClient)
{
    String^ sLogin = (String^) objParamList[0];

    cRegistry^ objReg = gcnew cRegistry();
    cLoginReg^ objLoginReg = gcnew cLoginReg();

    objLoginReg->m_sPassword = (String^) objParamList[1];
    objLoginReg->m_sCodec = (String^) objParamList[2];

    objLoginReg->m_bStealth = ((String^) objParamList[3] == "STEALTH-YES");
    objLoginReg->m_bBlock = ((String^) objParamList[4] == "BLOCK-YES");

    bool bUpdate = objReg->IsLoginExist(sLogin);
    ArrayList^ objSendParamList = gcnew ArrayList();

    if(objReg->SetLogin(sLogin, objLoginReg) == false)
    {
        objSendParamList->Add("Unable to add user.");

        objTelnetClient->SendCommand("MSG", objSendParamList);
        objTelnetClient->SendText("VaxTele:>");
        
        return;
    }

    objSendParamList->Add(sLogin);

    if(bUpdate)
        objTelnetClient->SendCommand("UpdateUser", objSendParamList);
    else
        objTelnetClient->SendCommand("AddUser", objSendParamList);
    
    objTelnetClient->SendText("VaxTele:>");
}

void cTelnetCmd::RemoveUser(ArrayList^ objParamList, cTelnetClient^ objTelnetClient)
{
    String^ sLogin = (String^) objParamList[0];

    cRegistry^ objReg = gcnew cRegistry();
    ArrayList^ objSendParamList = gcnew ArrayList();

    if(objReg->RemoveLogin(sLogin) == false)
    {
        objSendParamList->Add("Unable to remove user.");
        objTelnetClient->SendCommand("MSG", objSendParamList);
        objTelnetClient->SendText("VaxTele:>");

        return;
    }

    objSendParamList->Add(sLogin);

    objTelnetClient->SendCommand("RemoveUser", objSendParamList);
    objTelnetClient->SendText("VaxTele:>");
}

/**********************************************/

void cTelnetCmd::ShowQueues(cTelnetClient^ objTelnetClient)
{
    cRegistry^ objReg = gcnew cRegistry();
    ArrayList^ objQueueList = gcnew ArrayList();

    objReg->EnumQueue(objQueueList);

    objTelnetClient->SendCommand("ShowQueues", objQueueList);
    objTelnetClient->SendText("VaxTele:>");
}

void cTelnetCmd::QueueInfo(ArrayList^ objParamList, cTelnetClient^ objTelnetClient)
{
    String^ sQueueName = (String^) objParamList[0];

    cRegistry^ objReg = gcnew cRegistry();
    cQueueReg^ objQueueReg = gcnew cQueueReg();
    ArrayList^ objSendParamList = gcnew ArrayList();

    if(objReg->GetQueue(sQueueName, objQueueReg) == false)
    {
        objSendParamList->Add("Queue not found.");

        objTelnetClient->SendCommand("MSG", objSendParamList);
        objTelnetClient->SendText("VaxTele:>");

        return;
    }

    objSendParamList->Add(sQueueName);
    objSendParamList->Add(objQueueReg->m_sPlayWave);
    objSendParamList->Add(objQueueReg->m_sPressDigitPlayWave);

    ////////////////////////////////////////////

    String^ sQueueOPList = gcnew String("");
    
    PrepareToStr(objQueueReg->m_objQueueOPList, sQueueOPList);
    objSendParamList->Add(sQueueOPList);

    ////////////////////////////////////////////

    String^ sPressDigitList = gcnew String("");
    
    PrepareToStr(objQueueReg->m_objPressDigitList, sPressDigitList);
    objSendParamList->Add(sPressDigitList);

    ////////////////////////////////////////////
    
    String^ sPressDigitUserList = gcnew String("");
    
    PrepareToStr(objQueueReg->m_objPressDigitUserList, sPressDigitUserList);
    objSendParamList->Add(sPressDigitUserList);

    ////////////////////////////////////////////

    objTelnetClient->SendCommand("QueueInfo", objSendParamList);
    objTelnetClient->SendText("VaxTele:>");
}

void cTelnetCmd::AddQueue(ArrayList^ objParamList, cTelnetClient^ objTelnetClient)
{
    String^ sQueueName = (String^) objParamList[0];

    ///////////////////////////////////////

    bool bUpdate = (cServerSIP::m_objServerSIP->m_objQueueList->FindQueue(sQueueName) != nullptr);

    ///////////////////////////////////////

    String^ sPlayWave = (String^) objParamList[1];
    String^ sPressDigitPlayWave = (String^) objParamList[2];

    ///////////////////////////////////////
         
    ArrayList^ objQueueOPList = gcnew ArrayList();
    ParseToList((String^)objParamList[3], objQueueOPList);
            
    ///////////////////////////////////////
                    
    ArrayList^ objPressDigitList = gcnew ArrayList();
    ParseToList((String^)objParamList[4], objPressDigitList);

    ///////////////////////////////////////

    ArrayList^ objPressDigitUserList = gcnew ArrayList();
    ParseToList((String^)objParamList[5], objPressDigitUserList);
            
    ///////////////////////////////////////

    ArrayList^ objSendParamList = gcnew ArrayList();

    if(cServerSIP::m_objServerSIP->m_objQueueList->AddQueue(sQueueName, sPlayWave, sPressDigitPlayWave, objQueueOPList, objPressDigitList, objPressDigitUserList) == false)
    {
        objSendParamList->Add("Unable to add queue.");

        objTelnetClient->SendCommand("MSG", objSendParamList);
        objTelnetClient->SendText("VaxTele:>");

        return;
    }

    objSendParamList->Add(sQueueName);

    if(bUpdate)
        objTelnetClient->SendCommand("UpdateQueue", objSendParamList);
    else
        objTelnetClient->SendCommand("AddQueue", objSendParamList);
    
    objTelnetClient->SendText("VaxTele:>");
}


void cTelnetCmd::RemoveQueue(ArrayList^ objParamList, cTelnetClient^ objTelnetClient)
{
    String^ sQueueName = (String^) objParamList[0];
    cServerSIP::m_objServerSIP->m_objQueueList->RemoveQueue(sQueueName);

    ArrayList^ objSendParamList = gcnew ArrayList();
    objSendParamList->Add(sQueueName);

    objTelnetClient->SendCommand("RemoveQueue", objSendParamList);
    objTelnetClient->SendText("VaxTele:>");
}

/**********************************************/

void cTelnetCmd::ShowLines(cTelnetClient^ objTelnetClient)
{
    cRegistry^ objReg = gcnew cRegistry();

    ArrayList^ objLineList = gcnew ArrayList();
    objReg->EnumLine(objLineList);

    objTelnetClient->SendCommand("ShowLines", objLineList);
    objTelnetClient->SendText("VaxTele:>");
}

void cTelnetCmd::LineInfo(ArrayList^ objParamList, cTelnetClient^ objTelnetClient)
{
    String^ sLineName = (String^) objParamList[0];

    cRegistry^ objReg = gcnew cRegistry();

    cLineReg^ objLineReg = gcnew cLineReg();
    ArrayList^ objSendParamList = gcnew ArrayList();

    if(!objReg->GetLine(sLineName, objLineReg))
    {
        objSendParamList->Add("Line not found.");

        objTelnetClient->SendCommand("MSG", objSendParamList);
        objTelnetClient->SendText("VaxTele:>");

        return;
    }

    objSendParamList->Add(sLineName);

    objSendParamList->Add(objLineReg->m_sDisplayName);
    objSendParamList->Add(objLineReg->m_sUserName);
    objSendParamList->Add(objLineReg->m_sAuthUser);
    objSendParamList->Add(objLineReg->m_sPassword);
    objSendParamList->Add(objLineReg->m_sRealm);
    objSendParamList->Add(objLineReg->m_sProxy);
    objSendParamList->Add(objLineReg->m_sOutboundProxy);
    objSendParamList->Add(objLineReg->m_sCodec);

    if(objLineReg->m_bRegister)
        objSendParamList->Add("REGISTER-YES");
    else
        objSendParamList->Add("REGISTER-NO");
            
    objSendParamList->Add(objLineReg->m_sInCallType);
    objSendParamList->Add(objLineReg->m_sInCallTo);

    objTelnetClient->SendCommand("LineInfo", objSendParamList);
    objTelnetClient->SendText("VaxTele:>");

}

void cTelnetCmd::AddLine(ArrayList^ objParamList, cTelnetClient^ objTelnetClient)
{
    String^ sLineName = (String^) objParamList[0];
    String^ sDisplayName = (String^) objParamList[1];
    String^ sUserName = (String^) objParamList[2];
    String^ sAuthUser = (String^) objParamList[3];
    String^ sAuthPwd = (String^) objParamList[4];
    String^ sRealm = (String^) objParamList[5];
    String^ sProxy = (String^) objParamList[6];
    String^ sOutboundProxy = (String^) objParamList[7];
    String^ sCodec = (String^) objParamList[8];

    bool bRegister = ((String^) objParamList[9] == "REGISTER-YES");

    String^ sInCallType = (String^) objParamList[10];
    String^ sInCallTo = (String^) objParamList[11];

    bool bUpdate = (cServerSIP::m_objServerSIP->m_objLineList->FindLine(sLineName) != nullptr);

    ArrayList^ objSendParamList = gcnew ArrayList();

    if(!cServerSIP::m_objServerSIP->m_objLineList->AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sRealm, sProxy, sOutboundProxy, sCodec, bRegister, sInCallType, sInCallTo))
    {
        objSendParamList->Add("Unable to add line.");

        objTelnetClient->SendCommand("MSG", objSendParamList);
        objTelnetClient->SendText("VaxTele:>");

        return;
    }

    objSendParamList->Add(sLineName);

    if(bUpdate)
        objTelnetClient->SendCommand("UpdateLine", objSendParamList);
    else
        objTelnetClient->SendCommand("AddLine", objSendParamList);
    
    objTelnetClient->SendText("VaxTele:>");
}

void cTelnetCmd::RemoveLine(ArrayList^ objParamList, cTelnetClient^ objTelnetClient)
{
    String^ sLineName = (String^) objParamList[0];
    ArrayList^ objSendParamList = gcnew ArrayList();

    if(!cServerSIP::m_objServerSIP->m_objLineList->RemoveLine(sLineName))
    {
        objSendParamList->Add("Unable to remove line.");

        objTelnetClient->SendCommand("MSG", objSendParamList);
        objTelnetClient->SendText("VaxTele:>");

        return;
    }

    objSendParamList->Add(sLineName);

    objTelnetClient->SendCommand("RemoveLine", objSendParamList);
    objTelnetClient->SendText("VaxTele:>");
}

/**********************************************/

void cTelnetCmd::ShowDialPlans(cTelnetClient^ objTelnetClient)
{
    cRegistry^ objReg = gcnew cRegistry();

    ArrayList^ objDialPlanList = gcnew ArrayList();
    objReg->EnumDialPlan(objDialPlanList);

    cDialPlanReg^ objDialPlanReg = gcnew cDialPlanReg();
    ArrayList^ objSendParamList = gcnew ArrayList();
            
    for(int nCount = 0; nCount < objDialPlanList->Count; nCount++)
    {
        String^ sUserPrefix = (String^)objDialPlanList[nCount];
        objReg->GetDialPlan(sUserPrefix, objDialPlanReg);

        if (objDialPlanReg->m_sCallPrefix->Length == 0)
            objDialPlanReg->m_sCallPrefix = "None";

        objSendParamList->Add(sUserPrefix + "," + objDialPlanReg->m_sLineName + "," + objDialPlanReg->m_sCallPrefix);
    }

    objTelnetClient->SendCommand("ShowDialPlans", objSendParamList);
    objTelnetClient->SendText("VaxTele:>");
}

void cTelnetCmd::DialPlanInfo(ArrayList^ objParamList, cTelnetClient^ objTelnetClient)
{
    String^ sUserPrefix = (String^) objParamList[0];

    cRegistry^ objReg = gcnew cRegistry();
    cDialPlanReg^ objDialPlanReg = gcnew cDialPlanReg();

    ArrayList^ objSendParamList = gcnew ArrayList();

    if(!objReg->GetDialPlan(sUserPrefix, objDialPlanReg))
    {
        objSendParamList->Add("DialPlan or user prefix not found.");

        objTelnetClient->SendCommand("MSG", objSendParamList);
        objTelnetClient->SendText("VaxTele:>");

        return;
    }

    objSendParamList->Add(sUserPrefix);
    objSendParamList->Add(objDialPlanReg->m_sLineName);

    if (objDialPlanReg->m_sCallPrefix->Length == 0)
        objDialPlanReg->m_sCallPrefix = "None";

    objSendParamList->Add(objDialPlanReg->m_sCallPrefix);

    objTelnetClient->SendCommand("DialPlanInfo", objSendParamList);
    objTelnetClient->SendText("VaxTele:>");

}

void cTelnetCmd::AddDialPlan(ArrayList^ objParamList, cTelnetClient^ objTelnetClient)
{
    String^ sUserPrefix = (String^) objParamList[0];

    cRegistry^ objReg = gcnew cRegistry();
    cDialPlanReg^ objDialPlanReg = gcnew cDialPlanReg();
    ArrayList^ objSendParamList = gcnew ArrayList();

    objDialPlanReg->m_sLineName = (String^) objParamList[1];
    objDialPlanReg->m_sCallPrefix = (String^) objParamList[2];

    if(objReg->SetDialPlan(sUserPrefix, objDialPlanReg) == false)
    {
        objSendParamList->Add("Unable to add dialplan or user prefix.");

        objTelnetClient->SendCommand("MSG", objSendParamList);
        objTelnetClient->SendText("VaxTele:>");

        return;
    }

    cServerSIP::m_objServerSIP->m_objDialPlanList->ReLoadDialPlans();

    objSendParamList->Add(sUserPrefix);
    objSendParamList->Add(objDialPlanReg->m_sLineName);

    if (objDialPlanReg->m_sCallPrefix->Length == 0)
        objDialPlanReg->m_sCallPrefix = "None";

    objSendParamList->Add(objDialPlanReg->m_sCallPrefix);

    objTelnetClient->SendCommand("AddDialPlan", objSendParamList);
    objTelnetClient->SendText("VaxTele:>");

}

void cTelnetCmd::RemoveDialPlan(ArrayList^ objParamList, cTelnetClient^ objTelnetClient)
{
    String^ sUserPrefix = (String^) objParamList[0];

    ArrayList^ objSendParamList = gcnew ArrayList();
    cRegistry^ objReg = gcnew cRegistry();

    if(objReg->RemoveDialPlan(sUserPrefix) == false)
    {
        objSendParamList->Add("Unable to remove dialplan or user prefix.");
        objTelnetClient->SendCommand("MSG", objSendParamList);

        objTelnetClient->SendText("VaxTele:>");
        return;
    }
    
    cServerSIP::m_objServerSIP->m_objDialPlanList->ReLoadDialPlans();

    objSendParamList->Add(sUserPrefix);

    objTelnetClient->SendCommand("RemoveDialPlan", objSendParamList);
    objTelnetClient->SendText("VaxTele:>");
}

/*************************************************/

void cTelnetCmd::SetStealthMusic(ArrayList^ objParamList, cTelnetClient^ objTelnetClient)
{
    String^ sStealthMusic = (String^) objParamList[0];

    cRegistry^ objReg = gcnew cRegistry();
    objReg->SetStealthListenerMusic(sStealthMusic);

    ArrayList^ objSendParamList = gcnew ArrayList();
    objSendParamList->Add(sStealthMusic);

    objTelnetClient->SendCommand("SetStealthMusic", objSendParamList);
    objTelnetClient->SendText("VaxTele:>");
}

void cTelnetCmd::GetStealthMusic(cTelnetClient^ objTelnetClient)
{
    cRegistry^ objReg = gcnew cRegistry();

    ArrayList^ objSendParamList = gcnew ArrayList();
    objSendParamList->Add(objReg->GetStealthListenerMusic());

    objTelnetClient->SendCommand("GetStealthMusic", objSendParamList);
    objTelnetClient->SendText("VaxTele:>");
}

/*************************************************/

void cTelnetCmd::SetHoldMusic(ArrayList^ objParamList, cTelnetClient^ objTelnetClient)
{
    String^ sHoldMusic = (String^) objParamList[0];

    cRegistry^ objReg = gcnew cRegistry();
    objReg->SetHoldMusic(sHoldMusic);

    ArrayList^ objSendParamList = gcnew ArrayList();
    objSendParamList->Add(sHoldMusic);

    objTelnetClient->SendCommand("SetHoldMusic", objSendParamList);
    objTelnetClient->SendText("VaxTele:>");

}

void cTelnetCmd::GetHoldMusic(cTelnetClient^ objTelnetClient)
{
    cRegistry^ objReg = gcnew cRegistry();

    ArrayList^ objSendParamList = gcnew ArrayList();
    objSendParamList->Add(objReg->GetHoldMusic());

    objTelnetClient->SendCommand("GetHoldMusic", objSendParamList);
    objTelnetClient->SendText("VaxTele:>");
}

/*************************************************/

void cTelnetCmd::SetDialToneMusic(ArrayList^ objParamList, cTelnetClient^ objTelnetClient)
{
    String^ sDialToneMusic = (String^) objParamList[0];

    cRegistry^ objReg = gcnew cRegistry();
    objReg->SetDialToneMusic(sDialToneMusic);

    ArrayList^ objSendParamList = gcnew ArrayList();
    objSendParamList->Add(sDialToneMusic);

    objTelnetClient->SendCommand("SetDialToneMusic", objSendParamList);
    objTelnetClient->SendText("VaxTele:>");
}

void cTelnetCmd::GetDialToneMusic(cTelnetClient^ objTelnetClient)
{
    cRegistry^ objReg = gcnew cRegistry();

    ArrayList^ objSendParamList = gcnew ArrayList();
    objSendParamList->Add(objReg->GetDialToneMusic());

    objTelnetClient->SendCommand("GetDialToneMusic", objSendParamList);
    objTelnetClient->SendText("VaxTele:>");
}

/*************************************************/

void cTelnetCmd::GetCOMM(cTelnetClient^ objTelnetClient)
{
    cRegistry^ objReg = gcnew cRegistry();
    cDialPlanReg^ objDialPlanReg = gcnew cDialPlanReg();

    String^ sListenIP = gcnew String("");
    String^ sListenPort = gcnew String("");
    String^ sDominRealm = gcnew String("");

    objReg->GetComm(sListenIP, sListenPort, sDominRealm);

    ArrayList^ objSendParamList = gcnew ArrayList();

    objSendParamList->Add(sListenIP);
    objSendParamList->Add(sListenPort);
    objSendParamList->Add(sDominRealm);

    objTelnetClient->SendCommand("GetCOMM", objSendParamList);
    objTelnetClient->SendText("VaxTele:>");
}

void cTelnetCmd::SetCOMM(ArrayList^ objParamList, cTelnetClient^ objTelnetClient)
{
    cRegistry^ objReg = gcnew cRegistry();
    cDialPlanReg^ objDialPlanReg = gcnew cDialPlanReg();

    String^ sListenIP = (String^) objParamList[0];
    String^ sListenPort = (String^) objParamList[1];
    String^ sDominRealm = (String^) objParamList[2];

    objReg->SetComm(sListenIP, sListenPort, sDominRealm);

    objTelnetClient->SendCommand("SetCOMM", objParamList);
    objTelnetClient->SendText("VaxTele:>");
}

///////////////////////////////////////////

void cTelnetCmd::StartServer(cTelnetClient^ objTelnetClient)
{
    cRegistry^ objReg = gcnew cRegistry();
    objReg->SetStartServer(true);

    objTelnetClient->SendText("VaxTele:>");
}

void cTelnetCmd::StopServer(cTelnetClient^ objTelnetClient)
{
    cRegistry^ objReg = gcnew cRegistry();
    objReg->SetStartServer(false);

    objTelnetClient->SendText("VaxTele:>");
}

/////////////////////////////////////////

void cTelnetCmd::InvalidCommand(cTelnetClient^ objTelnetClient)
{
    objTelnetClient->SendText("VaxTele:>");
}

/////////////////////////////////////////

void cTelnetCmd::ParseToList(String^ sInputStr, ArrayList^% objOutputList)
{
    int nEnd = 0;

    while (sInputStr->Length != 0)
    {
        nEnd = sInputStr->IndexOf(",");

        if (nEnd == -1)
        {
            objOutputList->Add(sInputStr);
            break;
        }

        objOutputList->Add(sInputStr->Substring(0, nEnd));
        sInputStr = sInputStr->Remove(0, nEnd + 1);
    }
}

void cTelnetCmd::PrepareToStr(ArrayList^ objInputList, String^% sOutputStr)
{
    sOutputStr = "";
    int nCount = 0;

    for (nCount = 0; nCount < objInputList->Count; nCount++)
        sOutputStr = sOutputStr + objInputList[nCount] + ",";

    if (nCount > 0)
        sOutputStr = sOutputStr->Remove(sOutputStr->Length - 1, 1); // remove last comma ','
}
