// ServerData.cpp: implementation of the CServerData class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ServerSIP.h"
#include "Registry.h"
#include "ServerData.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CServerData::CServerData()
{
	m_lHoldSession = -1;
	m_lHoldPlayWaveId = -1;

	m_lDialToneWaveId = -1;
	m_lDialToneSession = -1;

	m_lStealthSession = -1;
	m_lStealthWaveId  = -1;
}

CServerData::~CServerData()
{
	
}

long CServerData::GetDialToneSessionId()
{
	return m_lDialToneSession;
}

long CServerData::GetStealthSessionId()
{
	return m_lStealthSession;
}

long CServerData::GetHoldSessionId()
{
	return m_lHoldSession;
}

void CServerData::UnLoadWavFiles()
{
	CServerSIP::m_pServerSIP->UnLoadWaveFileToSession(m_lHoldPlayWaveId, m_lHoldSession);
	CServerSIP::m_pServerSIP->UnLoadWaveFileToSession(m_lDialToneWaveId, m_lDialToneSession);
	CServerSIP::m_pServerSIP->UnLoadWaveFileToSession(m_lStealthWaveId, m_lStealthSession);
}

void CServerData::LoadWavFiles()
{
	CRegistry objReg;

	CString objHoldMusicWaveFile    = objReg.GetHoldMusic();
	CString objDialToneWaveFile     = objReg.GetDialToneMusic();
	CString objStealthMusicWaveFile = objReg.GetStealthListenerMusic();
	
	if(!objHoldMusicWaveFile.IsEmpty())
		CServerSIP::m_pServerSIP->LoadWaveFileToSession(objHoldMusicWaveFile, m_lHoldPlayWaveId, m_lHoldSession);

	if(!objDialToneWaveFile.IsEmpty())
		CServerSIP::m_pServerSIP->LoadWaveFileToSession(objDialToneWaveFile, m_lDialToneWaveId, m_lDialToneSession);

	if(!objStealthMusicWaveFile.IsEmpty())
		CServerSIP::m_pServerSIP->LoadWaveFileToSession(objStealthMusicWaveFile, m_lStealthWaveId, m_lStealthSession);
}

void CServerData::LoadServer()
{
	LoadWavFiles();
					
	CServerSIP::m_pServerSIP->m_objLineList.LoadLines();
	CServerSIP::m_pServerSIP->m_objDialPlanList.LoadDialPlans();
	CServerSIP::m_pServerSIP->m_objQueueList.LoadQueue();

	CServerSIP::m_pServerSIP->SetVaxTeleTick(QUEUE_TICK_ID, 2000); // 2 seconds.
}

void CServerData::UnLoadServer()
{
	UnLoadWavFiles();
	
	CServerSIP::m_pServerSIP->m_objLineList.UnLoadLines();
	CServerSIP::m_pServerSIP->m_objDialPlanList.UnLoadDialPlans();
	CServerSIP::m_pServerSIP->m_objQueueList.UnLoadQueue();

	CServerSIP::m_pServerSIP->KillVaxTeleTick(QUEUE_TICK_ID);
}


