// MainThread.cpp : implementation file
//

#include "stdafx.h"
#include "MainThread.h"
#include "ServerSIP/VaxTeleServerSIP.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define TM_THREAD_START		WM_USER + 100
#define TM_THREAD_STOP		WM_USER + 101

/////////////////////////////////////////////////////////////////////////////
// CMainThread

IMPLEMENT_DYNCREATE(CMainThread, CWinThread)

CMainThread::CMainThread()
{
}

CMainThread::~CMainThread()
{
}

BOOL CMainThread::InitInstance()
{
	m_pVaxTeleServerSIP = new CVaxTeleServerSIP;

	return TRUE;
}

int CMainThread::ExitInstance()
{
	delete m_pVaxTeleServerSIP;

	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(CMainThread, CWinThread)
	//{{AFX_MSG_MAP(CMainThread)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP

	ON_THREAD_MESSAGE(TM_THREAD_STOP, OnStopThread)
	ON_THREAD_MESSAGE(TM_THREAD_START, OnStartThread)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainThread message handlers

void CMainThread::OnStopThread(WPARAM wParam, LPARAM lParam)
{
	m_pVaxTeleServerSIP->StopServer();
	::PostQuitMessage(0);
}

void CMainThread::PostStopThread()
{
	PostThreadMessage(TM_THREAD_STOP, 0, 0);
	::WaitForSingleObject(m_hThread, INFINITE);
}

//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

void CMainThread::OnStartThread(WPARAM wParam, LPARAM lParam)
{
	m_pVaxTeleServerSIP->StartServer();
}

void CMainThread::PostStartThread()
{
	PostThreadMessage(TM_THREAD_START, 0, 0);
	
}
