using System;
using System.Collections;
using System.Text;

class cQueueData
{
    public int m_nQueueDigitDetectPlayWaveId;
    public int m_nQueuePlayWaveId;

    public Boolean m_bIsDigitDetect;
    public uint m_unQueueId;

    public ArrayList m_objAgentList = new ArrayList();
    public ArrayList m_objQueueCallList = new ArrayList();

    public Hashtable m_objDigitDetectList = new Hashtable();

    
    public cQueueData()
    {
        m_nQueueDigitDetectPlayWaveId = -1;
        m_unQueueId = 0;
        m_nQueuePlayWaveId = -1;
    }
}

class cQueueList
{
    private const int DETECT_DIGIT_TIME_START = 1;
    private const int DETECT_DIGIT_TIME_UP = 2;

    uint m_unQueueIdCount;

    Hashtable m_objQueueListTEXT = new Hashtable();
    Hashtable m_objQueueListINT  = new Hashtable();
    
    public cQueueList()
    {
        m_unQueueIdCount = 0;
    }

    public void UnLoadQueue()
    {
        DeleteAll();
    }

    public uint ChooseQueueId()
    {
        while (true)
        {
            m_unQueueIdCount = m_unQueueIdCount + 1;
            if (FindQueue(m_unQueueIdCount) == null) break;
        }

        return m_unQueueIdCount;
    }

    public void  LoadQueue()
    {

        cRegistry objReg = new cRegistry();
        ArrayList objQueueList = new ArrayList();

        if(objReg.EnumQueue(ref objQueueList) == false)
            return;

        cQueueReg objQueueReg = new cQueueReg();
        
        for(int nCount = 0; nCount < objQueueList.Count; nCount++)
        {
            if(objReg.GetQueue((string) objQueueList[nCount], ref objQueueReg) == false)
            {
                cServerSIP.m_objServerSIP.LogStatus("Unable to load queue [ " + (string)objQueueList[nCount] + " ] information from registry.");
                continue;
            }

            Add((string) objQueueList[nCount], objQueueReg.m_sPlayWave, objQueueReg.m_sPressDigitPlayWave, ref objQueueReg.m_objQueueOPList, ref objQueueReg.m_objPressDigitList, ref objQueueReg.m_objPressDigitUserList);
        }
    }

    public Boolean AddQueue(string sQueueName, string sQueuePlayWave, string sDigitPressPlayWave, ref ArrayList objAgentList, ref ArrayList objPressDigitList, ref ArrayList objUserDigitList)
    {
        cQueueReg objQueueReg = new cQueueReg();

        objQueueReg.m_sPlayWave = sQueuePlayWave;
        objQueueReg.m_sPressDigitPlayWave = sDigitPressPlayWave;

        objQueueReg.m_objQueueOPList = objAgentList;
        objQueueReg.m_objPressDigitList = objPressDigitList;
        objQueueReg.m_objPressDigitUserList = objUserDigitList;

        cRegistry objReg = new cRegistry();
        if(objReg.SetQueue(sQueueName, ref objQueueReg) == false)
            return false;

        Add(sQueueName, sQueuePlayWave, sDigitPressPlayWave, ref objAgentList, ref objPressDigitList, ref objUserDigitList);

        return true;
    }

    public Boolean RemoveQueue(string sQueueName)
    {
        cRegistry objReg = new cRegistry();

        if(objReg.RemoveQueue(sQueueName) == false)
            return false;
        
        Remove(sQueueName);
        return true;
    }

    private Boolean FindFreeUserId(ref ArrayList objListOP, ref string sFreeUserId)
    {
        for(int nCount = 0; nCount < objListOP.Count; nCount++)
        {
            if(cServerSIP.m_objServerSIP.m_objUserList.GetCallCount((string) objListOP[nCount]) == 0)
            {
                sFreeUserId = (string) objListOP[nCount];
                return true;
            }
        }

        return false;
    }

    private void PlayQueueWaveToCall(ref cCallData objCallData, int nQueueWaveId, Boolean bLoopPlay)
    {
        if(nQueueWaveId != -1)
            cServerSIP.m_objServerSIP.PlayWaveStartToCall(ref objCallData, nQueueWaveId, bLoopPlay);
    }
    
    public Boolean AddCallToQueue(ref cCallData objCallData)
    {
        cQueueData objQueueData = FindQueue(objCallData.m_unQueueId);
        if(objQueueData == null) return false;
        
        objQueueData.m_objQueueCallList.Add(objCallData);
        objCallData.m_bDigitDetect = objQueueData.m_bIsDigitDetect;

        UpdateCall(ref objCallData, ref objQueueData);
        return true;
    }

    private void UpdateCall(ref cCallData objCallData, ref cQueueData objQueueData)
    {
        if(objCallData.m_bDigitDetect)
        {
            cServerSIP.m_objServerSIP.EnableDetectDTMF(ref objCallData);
            PlayQueueWaveToCall(ref objCallData, objQueueData.m_nQueueDigitDetectPlayWaveId, false);
        }
        else
        {
            PlayQueueWaveToCall(ref objCallData, objQueueData.m_nQueuePlayWaveId, true);

            if(objQueueData.m_objQueueCallList.Count == 1)
                DistributeCall(ref objQueueData);
        }
    }

    public void  ProcessQueueTick()
    {
        IDictionaryEnumerator enumerator  = m_objQueueListINT.GetEnumerator();

        while(enumerator.MoveNext())
        {
            cQueueData objQueueData = (cQueueData) enumerator.Value;
            DistributeCall(ref objQueueData);
        }
    }


    private void DistributeCall(ref cQueueData objQueueData)
    {
        cCallData objQueueCallData;

        for(int nCount = 0; nCount < objQueueData.m_objQueueCallList.Count; nCount++)
        {
            objQueueCallData = (cCallData) objQueueData.m_objQueueCallList[nCount];

            if(objQueueCallData.m_bDigitDetect)
            {
                if (DistributeCallToDigitPressUser(ref objQueueData, ref objQueueCallData) == false)
                    continue;
            }   
            else
            {
                if (DistributeCallToQueueAgent(ref objQueueData, ref objQueueCallData) == false)
                    return;
            }

            objQueueData.m_objQueueCallList.RemoveAt(nCount);
        }
    }

    private Boolean DistributeCallToQueueAgent(ref cQueueData objQueueData, ref cCallData objQueueCallData)
    {
        string sFreeAgentUserId = "";

        if(FindFreeUserId(ref objQueueData.m_objAgentList, ref sFreeAgentUserId) == false)
            return false;
        
        cCallData objDialCallData = cServerSIP.m_objServerSIP.DialCallToUser(ref objQueueCallData, sFreeAgentUserId);
        if(objDialCallData == null) return false;

        PlayDialToneToCall(ref objQueueCallData);
        return true;
    }

    private Boolean DistributeCallToDigitPressUser(ref cQueueData objQueueData, ref cCallData objQueueCallData)
    {
        if(objQueueCallData.m_nDigitPRESS == DETECT_DIGIT_TIME_START)
        {
            objQueueCallData.m_nDigitPRESS = DETECT_DIGIT_TIME_UP;
            return false;
        }

        if(objQueueCallData.m_nDigitPRESS == DETECT_DIGIT_TIME_UP)
        {
            if(DialCallToDigitPRESS(ref objQueueData, ref objQueueCallData) == true)
                return true;
                
            cServerSIP.m_objServerSIP.DisableDetectDTMF(ref objQueueCallData);
            UpdateCall(ref objQueueCallData, ref objQueueData);
        }

        return false;
    }

    private Boolean DialCallToDigitPRESS(ref cQueueData objQueueData, ref cCallData objQueueCallData)
    {
        if(objQueueCallData.m_sDigitPRESS.Length == 0)
            return false;
            
        string sDigitPressUSER = "";

        if(FindUserForDigitPRESS(ref objQueueData, objQueueCallData.m_sDigitPRESS, ref sDigitPressUSER) == true)
        {
            cCallData objDialCallData = cServerSIP.m_objServerSIP.DialCallToUser(ref objQueueCallData, sDigitPressUSER);

            if(objDialCallData != null)
            {
                cServerSIP.m_objServerSIP.DisableDetectDTMF(ref objQueueCallData);
                PlayDialToneToCall(ref objQueueCallData);

                return true;
            }
        }

        return false;
    }

    private Boolean FindUserForDigitPRESS(ref cQueueData objQueueData, string sDigitPRESS, ref string sDigitPressUSER)
    {
        sDigitPressUSER = (string) objQueueData.m_objDigitDetectList[sDigitPRESS];

        if(sDigitPressUSER == null)
            return false;
        
        return true;
    }

    public void  OnPressDigitDTMF(ref cCallData objCallData, string sDigit)
    {
        cServerSIP.m_objServerSIP.PlayWaveStopToCall(ref objCallData);

        objCallData.m_sDigitPRESS += sDigit;
        objCallData.m_nDigitPRESS = DETECT_DIGIT_TIME_START;
    }

    public void OnPlayWaveDoneToCall(ref cCallData objCallData)
    {
        objCallData.m_nDigitPRESS = DETECT_DIGIT_TIME_START;
    }

    public void PlayDialToneToCall(ref cCallData objCallData)
    {
        int nDialToneSessionId = cServerSIP.m_objServerSIP.m_objServerData.GetDialToneSessionId();

        if(nDialToneSessionId != -1)
            cServerSIP.m_objServerSIP.AddCallToSession(ref objCallData, nDialToneSessionId);
    }

    public void  RemoveQueueCall(ref cCallData objCallData)
    {
        cQueueData objQueueData = FindQueue(objCallData.m_unQueueId);

        if(objQueueData == null)
            return;
        
        int nIndex = objQueueData.m_objQueueCallList.IndexOf(objCallData);
        
        if(nIndex != -1)
            objQueueData.m_objQueueCallList.RemoveAt(nIndex);
    }

    public cQueueData FindQueue(string sQueueName)
    {
        return (cQueueData) m_objQueueListTEXT[sQueueName.ToLower()];
    }

    public cQueueData FindQueue(uint unQueueId)
    {
        return (cQueueData) m_objQueueListINT[unQueueId];
    }

    public void  DeleteAll()
    {
        cQueueData objQueueData;
        IDictionaryEnumerator enumerator = m_objQueueListINT.GetEnumerator();

        while(enumerator.MoveNext())
        {
            objQueueData = (cQueueData)enumerator.Value;
            
            cServerSIP.m_objServerSIP.PlayWaveUnLoadFile(objQueueData.m_nQueuePlayWaveId);
            cServerSIP.m_objServerSIP.PlayWaveUnLoadFile(objQueueData.m_nQueueDigitDetectPlayWaveId);
        }

        m_objQueueListTEXT.Clear();
        m_objQueueListINT.Clear();
    }

    private void Remove(string sQueueName)
    {
        cQueueData objQueueData = FindQueue(sQueueName);
        
        if(objQueueData == null)
            return;
                
        for(int nCount = 0; nCount < objQueueData.m_objQueueCallList.Count; nCount++)
        {
            cCallData objQueueCallData = (cCallData) objQueueData.m_objQueueCallList[nCount];
            cServerSIP.m_objServerSIP.CloseCall(ref objQueueCallData);
        }

        m_objQueueListINT.Remove(objQueueData.m_unQueueId);
        m_objQueueListTEXT.Remove(sQueueName.ToLower());
    }

    private void Add(string sQueueName, string sQueuePlayWave, string sDigitPressPlayWave, ref ArrayList objAgentList, ref ArrayList objPressDigitList, ref ArrayList objUserDigitList)
    {
        Remove(sQueueName);

        int nPlayWaveId = -1;
        int nDigitPressPlayWaveId = -1;

        if (sQueuePlayWave.Length != 0)
        {
            cServerSIP.m_objServerSIP.LogStatus("Loading [ " + sQueuePlayWave + " ] wave file....");
            nPlayWaveId = cServerSIP.m_objServerSIP.PlayWaveLoadFile(sQueuePlayWave);

            if (nPlayWaveId == -1)
            {
                cServerSIP.m_objServerSIP.LogError("");
                cServerSIP.m_objServerSIP.LogStatus("Loading [ " + sQueuePlayWave + " ] wave file fail.");
            }
            else
            {
                cServerSIP.m_objServerSIP.LogStatus("Loading [ " + sQueuePlayWave + " ] wave file done.");
            }

        }

        if (sDigitPressPlayWave.Length != 0)
        {
            cServerSIP.m_objServerSIP.LogStatus("Loading [ " + sDigitPressPlayWave + " ] wave file....");
            nDigitPressPlayWaveId = cServerSIP.m_objServerSIP.PlayWaveLoadFile(sDigitPressPlayWave);

            if (nDigitPressPlayWaveId == -1)
            {
                cServerSIP.m_objServerSIP.LogError("");
                cServerSIP.m_objServerSIP.LogStatus("Loading [ " + sQueuePlayWave + " ] wave file fail.");
            }
            else
            {
                cServerSIP.m_objServerSIP.LogStatus("Loading [ " + sQueuePlayWave + " ] wave file done.");
            }
        }

        cQueueData objQueueData = new cQueueData();

        if (objPressDigitList.Count == 0)
            objQueueData.m_bIsDigitDetect = false;
        else
            objQueueData.m_bIsDigitDetect = true;

        int nCount;

        for (nCount = 0; nCount < objAgentList.Count; nCount++)
            objQueueData.m_objAgentList.Add(objAgentList[nCount]);

        for (nCount = 0; nCount < objPressDigitList.Count; nCount++)
            objQueueData.m_objDigitDetectList.Add(objPressDigitList[nCount], objUserDigitList[nCount]);

        objQueueData.m_unQueueId = ChooseQueueId();
        objQueueData.m_nQueueDigitDetectPlayWaveId = nDigitPressPlayWaveId;
        objQueueData.m_nQueuePlayWaveId = nPlayWaveId;

        m_objQueueListINT.Add(objQueueData.m_unQueueId, objQueueData);
        m_objQueueListTEXT.Add(sQueueName.ToLower(), objQueueData);

    }
   
}

